/*
 * discovery.h
 * (c) pcg@goof.com
 */

#ifndef DISCOVERY_H
#define DISCOVERY_H

#include <string>

#include "util.h"
#include "packet.h"

// discovery protocol
// implementation is in main.yy

struct ie_masks {
  u8 protocol_version;
  
  ie_mask src; // our own mask (when sending)
  ie_mask dst; // what we receive from the destination
  
  ie_masks (ie_mask s = 0, ie_mask d = 0) : protocol_version(0), src(s), dst(d) {};
};

// defined in main.yy
extern struct mask_map : map<const string, ie_masks, string_less_than> {
  mutex lock; // lock write access
  
  // check wether a server's masks is known.
  // if not, run the discover protocol
  // must be polled in regular intervals.
  ie_mask dst_mask (const char *server);
  
  // dump state
  void dump ();
} mask_map;

#endif

